//+------------------------------------------------------------------+
//|                                                Trend Analyst.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

// extract from SDX-Tz Pivots alert by Shimodax
// brax64 www forex-TSD.com


#property copyright "Copyright Shimodax"
#property link      "http://www.strategybuilderfx.com"

#property  indicator_separate_window

extern int ADX_period = 14;
extern int FI_period  = 14;
extern int RSI_period = 14;

color colt1, colt3, cola1, cola2, cola3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	deinit();
   return(0);
}

/*int deinit()
{
	
   ObjectsDeleteAll(0, OBJ_LABEL);
   ObjectDelete("ADX");  ObjectDelete("RSI");
   ObjectDelete("Signal");
   ObjectDelete("Analysis"); ObjectDelete("Strength"); ObjectDelete("Trend");

   return(0);
}*/


int deinit()
{
   string lookFor       = "TA_";
   int    lookForLength = StringLen(lookFor);   
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i);
         if(StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }         
   return(0);
}  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   string name = "TREND ANALYST";
   IndicatorShortName(name);
   int W = WindowFind(name);
     
   string ADX_Trend = "";
   string RSI_Trend = "";
   string FI_Trend  = "";
   
    //---- ADX
   double ADXP=iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_PLUSDI,0);
   double ADXM=iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_MINUSDI,0);
   
   if ((ADXP > ADXM)) { ADX_Trend = "UP"; colt1 = Lime; }
   if ((ADXP < ADXM)) { ADX_Trend = "DOWN"; colt1 = Red; }
 
   //---- FI
   double FI=iForce(NULL,0,FI_period,1,PRICE_CLOSE,0);
   
   if((FI > 0)) { FI_Trend ="UP";}
   if((FI < 0)) { FI_Trend ="DOWN";}

   //---- RSI
   double RSI=iRSI(NULL,0,RSI_period,PRICE_CLOSE,0);
   
   if((RSI > 50)) { RSI_Trend ="UP"; colt3 = Lime; }
   if((RSI < 50)) { RSI_Trend ="DOWN"; colt3 = Red; }

   //---- ANALYSIS
   string Analysis ="", Strength ="", Trend="";

   if(ADX_Trend=="UP"&&FI_Trend=="UP"&&RSI_Trend=="UP")
   {Analysis="UP"; cola1=Lime; Strength="Strong"; cola2=Lime; Trend="BULLISH"; cola3=Lime;}
   
   if(ADX_Trend=="UP"&&FI_Trend=="UP"&&RSI_Trend=="DOWN")
   {Analysis="UP"; cola1=Lime; Strength="Weak"; cola2=Green; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}
   
   if(ADX_Trend=="UP"&&FI_Trend=="DOWN"&&RSI_Trend=="UP")
   {Analysis="UP"; cola1=Lime; Strength="Weak"; cola2=Green; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}
   
   if(ADX_Trend=="UP"&&FI_Trend=="DOWN"&&RSI_Trend=="DOWN")
   {Analysis="DOWN"; cola1=Red; Strength="Weak"; cola2=FireBrick; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}
   
   if(ADX_Trend=="DOWN"&&FI_Trend=="DOWN"&&RSI_Trend=="DOWN")
   {Analysis="DOWN"; cola1=Red; Strength="Strong"; cola2=Red; Trend="BEARISH"; cola3=Red;}
   
   if(ADX_Trend=="DOWN"&&FI_Trend=="DOWN"&&RSI_Trend=="UP")
   {Analysis="DOWN"; cola1=Red; Strength="Weak"; cola2=FireBrick; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}
   
   if(ADX_Trend=="DOWN"&&FI_Trend=="UP"&&RSI_Trend=="DOWN")
   {Analysis="DOWN"; cola1=Red; Strength="Weak"; cola2=FireBrick; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}
   
   if(ADX_Trend=="DOWN"&&FI_Trend=="UP"&&RSI_Trend=="UP")
   {Analysis="UP"; cola1=Lime; Strength="Weak"; cola2=Green; Trend="SIDEWAYS"; cola3=DeepSkyBlue;}

   //---- CREATE LABELS
            ObjectCreate("TA_L1", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_L1","Analysis : ",10, "Verdana",Silver);
   ObjectSet("TA_L1", OBJPROP_CORNER, 0);
   ObjectSet("TA_L1", OBJPROP_XDISTANCE, 5);
   ObjectSet("TA_L1", OBJPROP_YDISTANCE, 20);
   
            ObjectCreate("TA_Analysis", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_Analysis",Analysis,11, "Verdana Bold", cola1);
   ObjectSet("TA_Analysis", OBJPROP_CORNER, 0);
   ObjectSet("TA_Analysis", OBJPROP_XDISTANCE, 75);
   ObjectSet("TA_Analysis", OBJPROP_YDISTANCE, 20);

            ObjectCreate("TA_Strength", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_Strength",Strength,11, "Verdana Bold Italic", cola2);
   ObjectSet("TA_Strength", OBJPROP_CORNER, 0);
   ObjectSet("TA_Strength", OBJPROP_XDISTANCE, 130);
   ObjectSet("TA_Strength", OBJPROP_YDISTANCE, 20);

            ObjectCreate("TA_L2", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_L2","Trend : ",10, "Verdana",Silver);
   ObjectSet("TA_L2", OBJPROP_CORNER, 0);
   ObjectSet("TA_L2", OBJPROP_XDISTANCE, 195);
   ObjectSet("TA_L2", OBJPROP_YDISTANCE, 20);

            ObjectCreate("TA_Trend", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_Trend",Trend,11, "Verdana Bold", cola3);
   ObjectSet("TA_Trend", OBJPROP_CORNER, 0);
   ObjectSet("TA_Trend", OBJPROP_XDISTANCE, 250);
   ObjectSet("TA_Trend", OBJPROP_YDISTANCE, 20);

         ObjectCreate("TA_L3", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_L3","RSI : ",10, "Verdana",Silver);
   ObjectSet("TA_L3", OBJPROP_CORNER, 0);
   ObjectSet("TA_L3", OBJPROP_XDISTANCE, 355);
   ObjectSet("TA_L3", OBJPROP_YDISTANCE, 20);

            ObjectCreate("TA_RSI", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_RSI",RSI_Trend,11, "Verdana Bold", colt3);
   ObjectSet("TA_RSI", OBJPROP_CORNER, 0);
   ObjectSet("TA_RSI", OBJPROP_XDISTANCE, 390);
   ObjectSet("TA_RSI", OBJPROP_YDISTANCE, 20);

         ObjectCreate("TA_L4", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_L4","ADX : ",10, "Verdana",Silver);
   ObjectSet("TA_L4", OBJPROP_CORNER, 0);
   ObjectSet("TA_L4", OBJPROP_XDISTANCE, 455);
   ObjectSet("TA_L4", OBJPROP_YDISTANCE, 20);

            ObjectCreate("TA_ADX", OBJ_LABEL, W, 0, 0);
   ObjectSetText("TA_ADX",ADX_Trend,11, "Verdana Bold", colt1);
   ObjectSet("TA_ADX", OBJPROP_CORNER, 0);
   ObjectSet("TA_ADX", OBJPROP_XDISTANCE, 495);
   ObjectSet("TA_ADX", OBJPROP_YDISTANCE, 20);
 
   return(0);
} 

